<?php

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

function cs_get_searchpic_values() {
    global $CONFIG;
    $superCage = Inspekt::makeSuperCage();

    $get_array = array("aid", "keyword");
    foreach($get_array as $key) {
        if ($superCage->get->keyExists($key)) {
            $values[$key] = trim(preg_replace("[\s+]", " ", $superCage->get->getRaw($key)));
        }
    }
    if (!is_array($values)) {
        $values = @unserialize(@base64_decode($superCage->cookie->getRaw($CONFIG['cookie_name']."_customsearch")));
    }

    return $values;
}

$thisplugin->add_filter('meta_album_get_pic_pos','cs_get_pic_pos');
function cs_get_pic_pos($album) {

    if (is_numeric($album)) {
        return $album;
    }

    global $CONFIG, $pid, $RESTRICTEDWHERE;

    $get = cs_get_searchpic_values();

    switch($album) {
        case 'customsearch':

            $query = "SELECT COUNT(*) FROM {$CONFIG['TABLE_PICTURES']} AS p
                INNER JOIN {$CONFIG['TABLE_ALBUMS']} AS r ON r.aid = p.aid
                $RESTRICTEDWHERE
                AND approved = 'YES'
                AND r.aid = {$get['aid']}
                AND keywords LIKE '%{$get['keyword']}%'
                AND pid < $pid";

                $result = cpg_db_query($query);

                list($pos) = mysql_fetch_row($result);
                mysql_free_result($result);
            return strval($pos);
            break;

        default: 
            return $album;
    }
}

$thisplugin->add_filter('meta_album', 'cs_meta_album');
function cs_meta_album($meta) {
    global $CONFIG, $CURRENT_CAT_NAME, $RESTRICTEDWHERE;

    $superCage = Inspekt::makeSuperCage();

    $get = cs_get_searchpic_values();
    setcookie($CONFIG['cookie_name']."_customsearch", base64_encode(serialize($get)));

    switch ($meta['album']) {

        case 'customsearch':
            $album_name = cpg_fetch_icon('search', 2)." ".$lang_plugin_more_meta_albums['mostvot_title'];
            if ($CURRENT_CAT_NAME) {
                $album_name .= " - $CURRENT_CAT_NAME";
            }

            $query = "SELECT pid FROM {$CONFIG['TABLE_PICTURES']} AS p 
                INNER JOIN {$CONFIG['TABLE_ALBUMS']} AS r ON r.aid = p.aid 
                $RESTRICTEDWHERE 
                AND approved = 'YES'
                AND r.aid = {$get['aid']}
                AND keywords LIKE '%{$get['keyword']}%'";
            $result = cpg_db_query($query);
            $count = mysql_num_rows($result);
            mysql_free_result($result);
            if (!$count) {
                $rowset = array();
                break;
            }

            $query = "SELECT p.* FROM {$CONFIG['TABLE_PICTURES']} AS p 
                INNER JOIN {$CONFIG['TABLE_ALBUMS']} AS r ON r.aid = p.aid 
                $RESTRICTEDWHERE 
                AND approved = 'YES'
                AND r.aid = {$get['aid']}
                AND keywords LIKE '%{$get['keyword']}%'
                ORDER BY pid ASC
                {$meta['limit']}";
            $result = cpg_db_query($query);
            $rowset = cpg_db_fetch_rowset($result);
            mysql_free_result($result);

            build_caption($rowset, array('pic_rating'));
            break;

        default:
            return $meta;
    }
    
    $meta['album_name'] = $album_name;
    $meta['count'] = $count;
    $meta['rowset'] = $rowset;

    return $meta;
}


?>
